from api.miscellaneous.constants import *

from api_test import ApiTest

_TEST_DATA_LOG_1 = {
    "time": "2024-03-14T16:12:52",
    "file_path": "pub/07ws-diskrete/07ws-diskrete-071211.mp4",
    "media_source_id": 1495,
    "course_id": 3,
    "course_full_name": "Diskrete Strukturen",
    "lecture_id": 25,
    "lecture_title": "Graphentheorie: Grundbegriffe, Datenstrukturen, Algorithmus für Breitensuche",
    "lecture_time": "2007-12-11T13:30:00"
}
_TEST_DATA_LOG_2 = {
    "time": "2024-03-14T15:12:52",
    "file_path": "pub/09ss-fosap/09ss-fosap-090423.mp4",
    "media_source_id": 214
}
_TEST_DATA_ERROR_LOG_1 = {
    "id": 1,
    "time": "2024-03-12T11:30:15",
    "file_path": "pub/09ss-fosap/09ss-fosap-091018.mp4",
    "matched_course_id": 13,
    "matched_lectures_ids": [
        10001,
        10002
    ]
}


class SorterTest(ApiTest):
    
    def test_get_log(self):
        self.do_json_request(
            "GET",
            "/sorter/log",
            expected_response_code=HTTP_401_UNAUTHORIZED
        )
        self.do_json_request(
            "GET",
            "/sorter/log",
            None,
            {
                "log": [_TEST_DATA_LOG_1, _TEST_DATA_LOG_2],
                "error_log": [_TEST_DATA_ERROR_LOG_1]
            },
            use_moderator_login=True,
        )
        self.do_json_request(
            "DELETE",
            "/sorter/error_log/1",
            expected_response_code=HTTP_401_UNAUTHORIZED
        )
        self.do_json_request(
            "DELETE",
            "/sorter/error_log/1",
            use_moderator_login=True
        )
        self.do_json_request(
            "GET",
            "/sorter/log",
            None,
            {
                "log": [_TEST_DATA_LOG_1, _TEST_DATA_LOG_2],
                "error_log": []
            },
            use_moderator_login=True,
        )
